/*
 File: la_expr_srcsym.cpp
 Date and Time: Fri Jan 30 18:55:13 2015 
*/
#include "la_expr_src.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_la_expr_src;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_la_expr_src::TH_la_expr_src(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_la_expr_src;
  NS_la_expr_src::Cla_expr_src Cla_expr_src_;// parallel-parser's parse table
#define ssPARSE_TABLE Cla_expr_src_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_la_expr_src::PROC_TH_la_expr_src(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_la_expr_src";
  static bool one_time(false);
  static NS_la_expr_src::Cla_expr_src* NS_la_expr_src_Cla_expr_src_(0);// parallel-parser's fsm table
  static Parser* NS_la_expr_src_Cla_expr_src_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_la_expr_src_Cla_expr_src_ = new NS_la_expr_src::Cla_expr_src();// parallel-parser's fsm table
    NS_la_expr_src_Cla_expr_src_parser = new Parser(*NS_la_expr_src_Cla_expr_src_,Caller_pp);
  }
 proc_parser = NS_la_expr_src_Cla_expr_src_parser;
#include "wproc_pp_core.h"
}
void 
Cla_expr_src::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rla_expr_src_:{
       Rla_expr_src* sym;
     if(re->rule_ == 0){
       sym = new Rla_expr_src(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rla_expr_src*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rtoks_:{
       Rtoks* sym;
     if(re->rule_ == 0){
       sym = new Rtoks(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoks*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rtoks_:{
       Rtoks* sym;
     if(re->rule_ == 0){
       sym = new Rtoks(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoks*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr5();
     return;}
    case rhs6_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs7_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     return;}
    case rhs8_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr8();
     return;}
    case rhs9_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr9();
     return;}
    case rhs10_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr10();
     return;}
    case rhs11_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr11();
     return;}
    case rhs12_Rtok_:{
       Rtok* sym;
     if(re->rule_ == 0){
       sym = new Rtok(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtok*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rla_minus_:{
       Rla_minus* sym;
     if(re->rule_ == 0){
       sym = new Rla_minus(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rla_minus*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rla_minus_:{
       Rla_minus* sym;
     if(re->rule_ == 0){
       sym = new Rla_minus(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rla_minus*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    default: return;
   }
}
